exec("./Support.cs");
exec("./Support_DynamicObjectMethods.cs");

if(isFunction(registerPreferenceAddon))
{
	registerPreferenceAddon("Tool_WrenchGhostBricks", "Wrench Ghost Bricks", "wrench");

	new ScriptObject(Preference)
	{
		className      = "WrenchGhostBricks";

		addon          = "Tool_WrenchGhostBricks";
		category       = "Wrench Ghost Bricks";
		title          = "Enable Ghost Brick Ray Casting";

		type           = "bool";
		params         = "";

		variable       = "$WrenchGhostBricks::EnableRayCasting";

		defaultValue   = "1";

		updateCallback = "WrenchGhostBricks_UpdateRayCastingPref";
		loadCallback   = "";

		hostOnly       = true;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};

	new ScriptObject(Preference)
	{
		className      = "WrenchGhostBricks";

		addon          = "Tool_WrenchGhostBricks";
		category       = "Wrench Ghost Bricks";
		title          = "Enable /wrenchGhostBrick, /wrenchGhost, /resetGhostBrick, /resetGhost";

		type           = "bool";
		params         = "";

		variable       = "$WrenchGhostBricks::EnableCommands";

		defaultValue   = "1";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};

	new ScriptObject(Preference)
	{
		className      = "WrenchGhostBricks";

		addon          = "Tool_WrenchGhostBricks";
		category       = "Wrench Ghost Bricks";
		title          = "Persistent Ghost Brick Attributes";

		type           = "bool";
		params         = "";

		variable       = "$WrenchGhostBricks::Persistent";

		defaultValue   = "1";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};
}

else
{
	$WrenchGhostBricks::EnableRayCasting = true;
	$WrenchGhostBricks::EnableCommands = true;
	$WrenchGhostBricks::Persistent = true;
}

function WrenchGhostBricks_UpdateRayCastingPref()
{
	%count = ClientGroup.getCount();

	for(%i = 0; %i < %count; %i++)
	{
		if(isObject(%client = ClientGroup.getObject(%i)) && isObject(%player = %client.player) && isObject(%brick = %player.tempBrick) && isObject(%shape = %brick.rayCastingObj))
			%shape.delete();
	}
}

datablock StaticShapeData(RayCastingBlockData)
{
	category = "Static Shapes";
	shapeFile = "./RayCastBlock.dts";
};

function serverCmdWrenchGhost(%client)
{
	serverCmdWrenchGhostBrick(%client);
}

function serverCmdWrenchGhostBrick(%client)
{
	if(!isObject(%player = %client.player) || !isObject(%tempBrick = %player.tempBrick) || !$WrenchGhostBricks::EnableCommands)
		return;

	%client.wrenchBrick = %tempBrick;
	%data = %tempBrick.getDataBlock();
	%type = %data.specialBrickType !$= "" ? %data.specialBrickType : %data.brickType;

	switch$(%type)
	{
		case "Sound":
			%tempBrick.sendWrenchSoundData(%client);
			commandToClient(%client, 'OpenWrenchSoundDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);

		case "VehicleSpawn":
			%tempBrick.sendWrenchVehicleSpawnData(%client);
			commandToClient(%client, 'OpenWrenchVehicleSpawnDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);

		case "BotSpawn" or "2":
			%tempBrick.sendWrenchData(%client);
			commandToClient(%client, 'OpenWrenchDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);
			commandToClient(%client, 'OpenWrenchBotHack');

		default:
			%tempBrick.sendWrenchData(%client);
			commandToClient(%client, 'OpenWrenchDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);
	}
}

function serverCmdResetGhost(%client)
{
	serverCmdResetGhostBrick(%client);
}

function serverCmdResetGhostBrick(%client)
{
	if(!isObject(%player = %client.player) || !isObject(%tempBrick = %player.tempBrick) || !$WrenchGhostBricks::EnableCommands)
		return;

	%brick = new fxDTSBrick()
	{
		angleID = %tempBrick.getAngleID();
		client = -1;
		colorFxID = 0;
		colorID = %tempBrick.getColorID();
		datablock = %tempBrick.getDataBlock();
		isBasePlate = 0;
		isPlanted = 0;
		position = %tempBrick.getPosition();
		printID = %tempBrick.getPrintID();
		rotation = %tempBrick.rotation;
		scale = "1 1 1";
		sahpeFxID = 0;
		stackBL_ID = -1;
	};

	%tempBrick.getGroup().add(%brick);
	%player.tempBrick = %brick;
	%tempBrick.delete();
}

function SceneObject::hideUnderFXPlane(%obj)
{
	switch$(%obj.getClassName())
	{
		case "particleEmitterNode":
			%obj.position = getWords(%obj.getPosition(), 0, 1) SPC "-9999";
			%obj.inspectPostApply();

		case "item":
			%obj.static = true;
			%obj.position = getWords(%obj.getPosition(), 0, 1) SPC "-9999";
			%obj.inspectPostApply();

		case "audioEmitter":
			%obj.setTransform(getWords(%obj.getPosition(), 0, 1) SPC "-9999");
	}
}

//This is to give ray casting to ghost bricks, since they don't have a typemask.
function fxDTSBrick::createRayCastBox(%brick)
{
	if(%brick.isPlanted || !$WrenchGhostBricks::EnableRayCasting)
	{
		if(isObject(%brick.rayCastingObj))
			%brick.rayCastingObj.delete();

		return;
	}

	if(!isObject(%brick.rayCastingObj))
	{
		%brick.rayCastingObj = new staticShape()
		{
			datablock = RayCastingBlockData;
			scale = "1 1 1";
			position = "0 0 0";
			rotation = "0 0 0 1";

			canSetIFLs = false;
			indestructible = true;

			brick = %brick;
		};

		missionCleanup.add(%brick.rayCastingObj);

		%brick.rayCastingObj.hideNode("ALL");
	}

	%scale = getWords(%brick.getObjectBox(), 3, 5);

	%brick.rayCastingObj.setScale(%scale);
	%brick.rayCastingObj.setTransform(%brick.getTransform());

	return %brick.rayCastingObj;
}

function fxDTSBrick::restoreTempBrick(%brick)
{
	if($WrenchGhostBricks::Persistent && !%brick.isPlanted && %client.tempBrickHasData)
	{
		%count = ClientGroup.getCount();

		for(%i = 0; %i < %count; %i++)
		{
			if(isObject(%client = ClientGroup.getObject(%i)) && isObject(%player = %client.player) && isObject(%tempBrick = %player.tempBrick) && %tempBrick == %brick)
			{
				%isTempBrick = true;
				break;
			}
		}

		if(%isTempBrick)
		{
			%brick.setNTObjectName(%client.tempBrickName);
			%brick.setColorFX(%client.tempBrickColorFX);
			%brick.setShapeFX(%client.tempBrickShapeFX);

			%brick.setSound(%client.tempBrickSound, %client);

			%brick.setVehicle(%client.tempBrickVehicle, %client);
			%brick.setReColorVehicle(%client.tempBrickReColorVehicle);

			%brick.setLight(%client.tempBrickLight, %client);

			%brick.setEmitter(%client.tempBrickEmitter, %client);
			%brick.setEmitterDirection(%client.tempBrickEmitterDirection);

			%brick.setItem(%client.tempBrickItem, %client);
			%brick.setItemPosition(%client.tempBrickItemPosition);
			%brick.setItemDirection(%client.tempBrickItemDirection);
			%brick.setItemRespawnTime(%client.tempBrickItemRespawnTime);

			%brick.setRayCasting(%client.tempBrickRayCasting);
			%brick.setColliding(%client.tempBrickColliding);
			%brick.setRendering(%client.tempBrickRendering);

			for(%i = 0; %i < %client.tempBrickNumEvents; %i++)
			{
				%enabled = %client.tempBrickEventEnabled[%i];
				%delay = %client.tempBrickEventDelay[%i];
				%inputEvent = %client.tempBrickEventInput[%i];
				%target = %client.tempBrickEventTarget[%i];
				%outputEvent = %client.tempBrickEventOutput[%i];
				%par1 = %client.tempBrickEventOutputParameter[%i, 1];
				%par2 = %client.tempBrickEventOutputParameter[%i, 2];
				%par3 = %client.tempBrickEventOutputParameter[%i, 3];
				%par4 = %client.tempBrickEventOutputParameter[%i, 4];

				%brick.addEvent(%enabled, %delay, %inputEvent, %target, %outputEvent, %par1, %par2, %par3, %par4);
			}

			%client.deleteAttributes("tempBrick*");
		}
	}
}

package WrenchGhostBricks
{
	function serverCmdPlantBrick(%client)
	{
		if(isObject(%player = %client.player) && isObject(%tempBrick = %player.tempBrick) && isObject(%shape = %tempBrick.rayCastingObj))
			%shape.delete();

		%brick = parent::serverCmdPlantBrick(%client);

		if(!isObject(%brick) || !isObject(%player) || !isObject(%tempBrick))
			return %brick;

		%brick.setNTObjectName(%tempBrick.getName());
		%brick.setColorFX(%tempBrick.getColorFxID());
		%brick.setShapeFX(%tempBrick.getShapeFxID());

		%data = %brick.getDataBlock();
		%type = %data.specialBrickType !$= "" ? %data.specialBrickType : %data.brickType;

		switch$(%type)
		{
			case "Sound":
				%brick.setSound(isObject(%tempBrick.audioEmitter) ? %tempBrick.audioEmitter.getProfileID() : 0, %client);

			case "VehicleSpawn":
				%brick.setVehicle(%tempBrick.vehicleDataBlock, %client);
				%brick.setReColorVehicle(%tempBrick.reColorVehicle);

				%brick.setRayCasting(%tempBrick.isRayCasting());
				%brick.setColliding(%tempBrick.isColliding());
				%brick.setRendering(%tempBrick.isRendering());

			case "BotSpawn" or "2":
				%brick.setItem(isObject(%tempBrick.item) ? %tempBrick.item.getDataBlock() : 0, %client);

				//Bot respawn time on bot spawn bricks is actually stored as item respawn time.
				%brick.setItemRespawnTime(%tempBrick.itemRespawnTime);
				//Keep Bot on bot spawn bricks is actually stored as item position(I think).
				%brick.setItemPosition(%tempBrick.itemPosition);

				%brick.setRayCasting(%tempBrick.isRayCasting());
				%brick.setColliding(%tempBrick.isColliding());
				%brick.setRendering(%tempBrick.isRendering());

			default:
				%brick.setLight(isObject(%tempBrick.getLightID()) ? %tempBrick.getLightID().getDataBlock() : 0, %client);

				%brick.setEmitter(isObject(%tempBrick.emitter) ? %tempBrick.emitter.getEmitterDataBlock() : 0, %client);
				%brick.setEmitterDirection(%tempBrick.emitterDirection);

				%brick.setItem(isObject(%tempBrick.item) ? %tempBrick.item.getDataBlock() : 0, %client);
				%brick.setItemPosition(%tempBrick.itemPosition);
				%brick.setItemDirection(%tempBrick.itemDirection);
				%brick.setItemRespawnTime(%tempBrick.itemRespawnTime);

				%brick.setRayCasting(%tempBrick.isRayCasting());
				%brick.setColliding(%tempBrick.isColliding());
				%brick.setRendering(%tempBrick.isRendering());
		}

		for(%i = 0; %i < %tempBrick.numEvents; %i++)
		{
			%enabled = %tempBrick.eventEnabled[%i];
			%delay = %tempBrick.eventDelay[%i];
			%inputEvent = %tempBrick.eventInput[%i];
			%target = %tempBrick.eventTarget[%i];
			%outputEvent = %tempBrick.eventOutput[%i];
			%par1 = %tempBrick.eventOutputParameter[%i, 1];
			%par2 = %tempBrick.eventOutputParameter[%i, 2];
			%par3 = %tempBrick.eventOutputParameter[%i, 3];
			%par4 = %tempBrick.eventOutputParameter[%i, 4];

			%brick.addEvent(%enabled, %delay, %inputEvent, %target, %outputEvent, %par1, %par2, %par3, %par4);
		}

		return %brick;
	}

	function fxDTSBrick::setEmitter(%brick, %emitter, %client)
	{
		%parent = parent::setEmitter(%brick, %emitter, %client);

		if(isObject(%emitter = %brick.emitter) && isObject(%client) && isObject(%player = %client.player) && isObject(%player.tempBrick) && %brick == %player.tempBrick)
			%emitter.schedule(0, hideUnderFXPlane);

		return %parent;
	}

	function fxDTSBrick::setItem(%brick, %itemData, %client)
	{
		%parent = parent::setItem(%brick, %itemData, %client);

		if(isObject(%item = %brick.item) && isObject(%client) && isObject(%player = %client.player) && isObject(%player.tempBrick) && %brick == %player.tempBrick)
			%item.schedule(0, hideUnderFXPlane);

		return %parent;
	}

	function fxDTSBrick::setSound(%brick, %soundData, %client)
	{
		%parent = parent::setSound(%brick, %soundData, %client);

		if(isObject(%sound = %brick.audioEmitter) && isObject(%client) && isObject(%player = %client.player) && isObject(%player.tempBrick) && %brick == %player.tempBrick)
			%sound.hideUnderFXPlane();

		return %parent;
	}

	function fxDTSBrick::spawnVehicle(%brick)
	{
		if(%brick.isPlanted)
			parent::spawnVehicle(%brick);
	}

	function fxDTSBrick::setRayCasting(%brick, %bool)
	{
		if(!%brick.isPlanted)
		{
			%brick.fakeRayCasting = %bool;
			%bool = true;
		}

		parent::setRayCasting(%brick, %bool);
	}

	function fxDTSBrick::isRayCasting(%brick)
	{
		if(!%brick.isPlanted)
			return %brick.fakeRayCasting;

		return parent::isRayCasting(%brick);
	}

	function WrenchImage::onPreFire(%data, %player, %slot)
	{
		parent::onPreFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
			%brick.createRayCastBox();
	}

	function WrenchImage::onHitObject(%data, %player, %slot, %hitObj, %hitPos, %hitNormal)
	{
		if(isObject(%client = %player.client) && %hitObj.getClassName() $= "StaticShape" && %hitObj.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%hitObj.brick))
		{
			%shape = %hitObj;
			%hitObj = %hitObj.brick;

			if(getTrustLevel(%player, %hitObj) < 3)
				return parent::onHitObject(%data, %player, %slot, %hitObj, %hitPos, %hitNormal);

			%client.wrenchBrick = %hitObj;
			%hitData = %hitObj.getDataBlock();
			%type = %hitData.specialBrickType !$= "" ? %hitData.specialBrickType : %hitData.brickType;

			switch$(%type)
			{
				case "Sound":
					%hitObj.sendWrenchSoundData(%client);
					commandToClient(%client, 'OpenWrenchSoundDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);

				case "VehicleSpawn":
					%hitObj.sendWrenchVehicleSpawnData(%client);
					commandToClient(%client, 'OpenWrenchVehicleSpawnDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);

				case "BotSpawn" or "2":
					%hitObj.sendWrenchData(%client);
					commandToClient(%client, 'OpenWrenchDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);
					commandToClient(%client, 'OpenWrenchBotHack');

				default:
					%hitObj.sendWrenchData(%client);
					commandToClient(%client, 'OpenWrenchDlg', "Ghost Brick", true, false, $Server::WrenchEventsAdminOnly);
			}

			serverPlay3D(wrenchHitSound, %hitPos);

			return %brick;
		}

		return parent::onHitObject(%data, %player, %slot, %hitObj, %hitPos, %hitNormal);
	}

	function WrenchImage::onStopFire(%data, %player, %slot)
	{
		parent::onStopFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && isObject(%shape = %brick.rayCastingObj))
			%shape.delete();
	}

	function fxDTSBrick::onAdd(%brick)
	{
		parent::onAdd(%brick);

		if(!%brick.isPlanted)
			%brick.fakeRayCasting = true;

		%brick.schedule(0, restoreTempBrick);
	}

	function PrintGunImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}

			%start = %player.getEyePoint();
			%vec = %player.getEyeVector();
			%end = vectorAdd(%start, vectorScale(%vec, 10));
			%mask = $TypeMasks::FxBrickAlwaysObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::TerrainObjectType;

			%raycast = containerRayCast(%start, %end, %mask, 0);

			if(!isObject(%hitObj = firstWord(%raycast)) || %hitObj.getClassName() !$= "StaticShape" || %hitObj.getDataBlock().getName() !$= "RayCastingBlockData" || !isObject(%brick = %hitObj.brick))
				return;

			%hitPos = getWords(%raycast, 1, 3);
			%hitNorm = getWords(%raycast, 4, 6);

			%data.onHitObject(%player, %slot, %brick, %hitPos, %hitNormal);
		}
	}

	function flatSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function flatPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function pearlSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function pearlPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function chromeSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function chromePaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function glowSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function glowPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function blinkSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function blinkPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function swirlSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function swirlPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function rainbowSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function rainbowPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function stableSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function stablePaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function jelloSprayCanImage::onFire(%data, %player, %slot)
	{
		parent::onFire(%data, %player, %slot);

		if(isObject(%brick = %player.tempBrick) && vectorDist(%brick.getPosition(), %player.getPosition()) <= 40)
		{
			%shape = %brick.createRayCastBox();

			if(isObject(%shape))
			{
				cancel(%shape.deleteSched);
				%shape.deleteSched = %shape.schedule(50, delete);
			}
		}
	}

	function jelloPaintProjectile::onCollision(%data, %proj, %col, %fade, %pos, %norm)
	{
		if(%col.getClassName() $= "StaticShape" && %col.getDataBlock().getName() $= "RayCastingBlockData" && isObject(%brick = %col.brick))
			%col = %brick;

		return parent::onCollision(%data, %proj, %col, %fade, %pos, %norm);
	}

	function fxDTSBrick::onRemove(%brick)
	{
		if(isObject(%brick.rayCastingObj))
			%brick.rayCastingObj.delete();

		if($WrenchGhostBricks::Persistent && !%brick.isPlanted)
		{
			%count = ClientGroup.getCount();

			for(%i = 0; %i < %count; %i++)
			{
				if(isObject(%client = ClientGroup.getObject(%i)) && isObject(%player = %client.player) && isObject(%tempBrick = %player.tempBrick) && %tempBrick == %brick)
				{
					%isTempBrick = true;
					break;
				}
			}

			if(%isTempBrick)
			{
				%client.tempBrickHasData = true;

				%client.tempBrickName = %brick.getName();
				%client.tempBrickColorFX = %brick.getColorFxID();
				%client.tempBrickShapeFX = %brick.getShapeFxID();

				%client.tempBrickSound = isObject(%brick.audioEmitter) ? %brick.audioEmitter.getProfileID() : 0;

				%client.tempBrickVehicle = %brick.vehicleDataBlock;
				%client.tempBrickReColorVehicle = %brick.reColorVehicle;

				%client.tempBrickLight = isObject(%brick.getLightID()) ? %brick.getLightID().getDataBlock() : 0;

				%client.tempBrickEmitter = isObject(%brick.emitter) ? %brick.emitter.getEmitterDataBlock() : 0;
				%client.tempBrickEmitterDirection = %brick.emitterDirection;

				%client.tempBrickItem = isObject(%brick.item) ? %brick.item.getDataBlock() : 0;
				%client.tempBrickItemPosition = %brick.itemPosition;
				%client.tempBrickItemDirection = %brick.itemDirection;
				%client.tempBrickItemRespawnTime = %brick.itemRespawnTime;

				%client.tempBrickRayCasting = %brick.isRayCasting();
				%client.tempBrickColliding = %brick.isColliding();
				%client.tempBrickRendering = %brick.isRendering();

				for(%i = 0; %i < %brick.numEvents; %i++)
				{
					%client.tempBrickEventEnabled[%i] = %brick.eventEnabled[%i];
					%client.tempBrickEventDelay[%i] = %brick.eventDelay[%i];
					%client.tempBrickEventInput[%i] = %brick.eventInput[%i];
					%client.tempBrickEventTarget[%i] = %brick.eventTarget[%i];
					%client.tempBrickEventOutput[%i] = %brick.eventOutput[%i];
					%client.tempBrickEventOutputParameter[%i, 1] = %brick.eventOutputParameter[%i, 1];
					%client.tempBrickEventOutputParameter[%i, 2] = %brick.eventOutputParameter[%i, 2];
					%client.tempBrickEventOutputParameter[%i, 3] = %brick.eventOutputParameter[%i, 3];
					%client.tempBrickEventOutputParameter[%i, 4] = %brick.eventOutputParameter[%i, 4];
				}

				%client.tempBrickNumEvents = %brick.numEvents;
			}
		}

		parent::onRemove(%brick);
	}
};
activatePackage(WrenchGhostBricks);